BROKER = "192.168.87.100" 
BRPORT = 1883
BRUSER = ""
BRPWD  = "" 
CLIENTID = "ESP8266y-" ..  node.chipid()

SWITCH_PIN = 0

SWITCH_ID = 0

topics = {"IoT/Watchdog", "IoT/Switch" .. SWITCH_ID} 
pub_sem = 0 
current_topic  = 1
topicsub_delay = 50 
id2 = 0

switch_state = 0


-- gpio.mode(SWITCH_PIN, gpio.OUTPUT)
-- gpio.write(SWITCH_PIN, gpio.LOW)

print("Connecting to MQTT broker. Please wait...")
m = mqtt.Client( CLIENTID, 120, BRUSER, BRPWD)
print("step 1")
tmr.alarm(4, 15, 1, mqtt_watchdog_expired)
print("step 2")
m:connect( BROKER , BRPORT, 0, function(conn)
     print("Connected to MQTT:" .. BROKER .. ":" .. BRPORT .." as " .. CLIENTID )
     mqtt_sub()
end)
print("step 3")



function mqtt_watchdog_expired()
    print("mqtt watchdog expired")
end

function mqtt_sub()
     if table.getn(topics) < current_topic then
          run_main_prog()
     else
          m:subscribe(topics[current_topic] , 0, function(conn)
               print("Subscribing topic: " .. topics[current_topic - 1] )
          end)
          current_topic = current_topic + 1 
          tmr.alarm(5, topicsub_delay, 0, mqtt_sub )
     end
end


function publish_status()
   if pub_sem == 0 then 
     pub_sem = 1
     local uptime = tmr.time()
     local msg = "{\"metadata\":{\"device\":\"WiFiSwitch" .. SWITCH_ID .. "\"}, \"data\":{\"uptime\":" .. uptime .. ", \"state\":" .. switch_state .. "}}"
     m:publish("IoT/Status/WiFiSwitch" .. SWITCH_ID, msg ,0,0, function(conn) 
        print("Status sent: " .. id2)
        print("State: " .. switch_state)
        pub_sem = 0 
        id2 = id2 +1 
     end)
   end  
end



function run_main_prog()
     tmr.alarm(3, 1000, 1, publish_status )
     m:on("message", function(conn, topic, data)
        print(topic .. ":" )
        if (data ~= nil ) then
          print ( data )
          if (data == "switch on") then
            switch_state = 1
            gpio.write(SWITCH_PIN, gpio.HIGH)
          elseif (data == "switch off") then
            switch_state = 0
            gpio.write(SWITCH_PIN, gpio.LOW)
          end
        end
      end )
end

